/*****************************************************
Date    : 05.03.2013
Author  : Marusya

Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 16.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

// Standard Input/Output functions
#include <stdio.h>

#define ADC_VREF_TYPE 0x60  

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here


// Port B initialization   (  - )
PORTB=0x00;
DDRB=0x00;

// Port C initialization   (  - )
PORTC=0x00;
DDRC=0xFF;
//DDRC=0x70;

// Port D initialization  (PD1 - )
PORTD=0x02;
DDRD=0x02;

// Timer/Counter 0 initialization
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

/* USART initialization     Communication Parameters: 8 Data, 1 Stop, No Parity
USART Receiver: Off         USART Transmitter: On
USART Mode: Asynchronous    USART Baud Rate: 9600
*/
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x67;

// Analog Comparator initialization
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AVCC pin
// Only the 8 most significant bits of
// the AD conversion result are used
//ADMUX=ADC_VREF_TYPE & 0xff;
//ADCSRA=0x84;
ADMUX = 0b01000010; // 1-2.REFS1=0, REFS0=1 -  , 3.ADLAR=0 -  - , 4.=0, 5-8.MUX3...0 -    - MUX=0010 - ADC2(2)
ADCSRA=0xAF;   // 1010 1111 (1.ADEN=1 - , 2.ADSC=0 -  -, 3.ADFR -   , 4.ADIF=0 -   , 5.ADIE=1 -    ,  3 -   -)

while (1)
      {
      unsigned int ad;  
      delay_ms(30);
      ADCSRA |= (1 << ADSC);    // 
      while ((ADCSRA&(1 << ADIF))== 0); //       
      
      //ad = (unsigned char) (ADCW);      
      ad = (ADCL|ADCH << 8);  //   ADC
      //delay_ms(30);          //
      while(!(UCSRA&1<<(UDRE)));
      UDR=ad;
      //UDR='a';
      delay_ms(60);    
      
      
      };
}
